% esempio di filtro passa banda di un segnale corrotto da rumore
% gaussiano (per aiutare leggibilità del codice commenti già inseriti
% nell'esercitazione 1 sono omessi)
clc
clear all
close all

%definizione asse temporale
tmin=0;
tmax=10;
dt=0.001;
t=tmin:dt:tmax;

%definizione di segnale
f0=1;
x=cos(2*pi*f0*t); %segnale utile (quello che voglio provare a ricostruire)
n=randn(1,length(t)); % rumore guassiano bianco a media nulla e varianza unitaria
xn=x+n;  %segnale rumoroso
figure,plot(t,x) %visualizzione del segnale utile 
% da usare come confronto per valuatare i susseguenti filtri
figure,plot(t,xn)

%trasformate di fourier di segnale utile e rumoroso
fmax=1/dt;
f=linspace(-fmax/2,fmax/2,length(t));
X=fftshift(fft(x));
figure,plot(f,abs(X))
Xn=fftshift(fft(xn));
figure,plot(f,abs(Xn))

%definizione e applicazione del filtro passa basso
Hl=zeros(1,length(t));
Hl(abs(f)<1.1)=1;
figure, plot(f,Hl)
Xf=Xn.*Hl;
figure,plot(f,abs(Xf))
xf=ifft(ifftshift(Xf));
figure,plot(t,xf)

%definizione e applicazione del filtro passa banda
Hb=zeros(1,length(t));
Hb(abs(f)<1.1)=1;
Hb(abs(f)<0.9)=0;
% da notare che si sceglie un filtro centrato nella frequenza del segnale
% utile sufficientemente stretto da eliminare gran parte del rumore
figure, plot(f,Hb)
Xf2=Xn.*Hb;
figure,plot(f,abs(Xf2))
xf2=ifft(ifftshift(Xf2));
figure,plot(t,xf2)

%confrontare i risultati del filtraggio passa basso (xl) e passa banda (xb)
%con il segnale originale (x).